package com.yihu.hos.app.dao;

import com.yihu.hos.app.model.App;
import com.yihu.hos.web.framework.dao.SQLGeneralDAO;
import com.yihu.hos.web.framework.model.Result;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * Created by chenweida on 2016/1/21.
 */
@Repository("appDao")
public class AppDao extends SQLGeneralDAO {
    public static final String BEAN_ID = "appDao";

    public Result getAppList(Map<String, Object> params) throws Exception {
        StringBuilder sb = new StringBuilder("from App t where 1=1 ");
        if (!StringUtils.isEmpty(params.get("status"))) //是否有效
        {
            sb.append(" and t.status = '" + params.get("status") + "'");
        }
        Object name = params.get("name");
        if (!StringUtils.isEmpty(name)) {
            sb.append(" and (t.name like '%" + name + "%' or t.code like '%" + name + "%')");
        }
        sb.append(" order by t.createDate desc");
        return super.getDataGridResult(sb.toString(), Integer.valueOf(params.get("page").toString()), Integer.valueOf(params.get("rows").toString()));

    }

    public List<App> getAllApplist() throws Exception {
        return (List<App>) super.hibernateTemplate.find("from App");
    }

    public List<App> findByCode(String code) throws Exception {
        List<App> apps = (List<App>) super.hibernateTemplate.find("from App where code=?", code);
        return apps;
    }

    public List<App> getAllByIdList(List<String> idList) {
        Session session = getCurrentSession();
        Criteria criteria = session.createCriteria(App.class);
        criteria.add(Restrictions.in("id", idList));
        return criteria.list();
    }

    public List<App> getListByCondition(String appIds, String catalog, String manageType) {
        List<App> apps = null;
        String hql = "FROM App WHERE 1=1";
        if(!StringUtils.isEmpty(catalog)){
            hql+=" and catalog = '"+catalog+"'";
        }
        if(!StringUtils.isEmpty(manageType)){
            hql+=" and manageType = '"+manageType+"'";
        }
        if(!StringUtils.isEmpty(appIds)){
            hql+=" and id in (:ids)";
            List<String> ids = Arrays.asList(appIds.split(","));
            Query query = getCurrentSession().createQuery(hql);
            query.setParameterList("ids",ids);
            apps = query.list();
            return apps;
        }
        Query query = getCurrentSession().createQuery(hql);
        apps = query.list();
        return apps;
    }
}
