package com.yihu.hos.app.dao;

import com.yihu.hos.app.model.AppFeature;
import com.yihu.hos.web.framework.dao.SQLGeneralDAO;
import com.yihu.hos.web.framework.model.DataGridResult;
import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * Created by chenweida on 2016/1/21.
 */
@Repository("appFeatureDao")
public class AppFeatureDao extends SQLGeneralDAO {
    public static final String BEAN_ID = "appFeatureDao";

    public DataGridResult getAppFeatureList(Map<String, Object> params, Integer page, Integer rows) throws Exception {
        StringBuilder sb = new StringBuilder("from AppFeature t where 1=1 ");
        if (!StringUtils.isEmpty(params.get("id"))) {
            sb.append(" and t.id = '" + params.get("id") + "'");
        }
        Object name = params.get("name");
        if (!StringUtils.isEmpty(name)) {
            sb.append(" and (t.name like '%" + name + "%' or t.code like '%" + name + "%')");
        }
        if (!StringUtils.isEmpty(params.get("code"))) {
            sb.append(" and t.code = '" + params.get("code") + "'");
        }
        if (!StringUtils.isEmpty(params.get("type"))) {
            sb.append(" and t.type = '" + params.get("type") + "'");
        }
        if (!StringUtils.isEmpty(params.get("parentId"))) {
            sb.append(" and t.parentId = " + params.get("parentId") );
        }
        if (!StringUtils.isEmpty(params.get("appId"))) {
            sb.append(" and t.appId = '" + params.get("appId") + "'");
        }
        return super.getDataGridResult(sb.toString(), page, rows);

    }

    public List<AppFeature> getAllApplist() throws Exception {
        return (List<AppFeature>) super.hibernateTemplate.find("from AppFeature");
    }

    public List<AppFeature> findByCode(String code) throws Exception {
        List<AppFeature> appFeature = (List<AppFeature>) super.hibernateTemplate.find("from AppFeature where code=?", code);
        return appFeature;
    }

    public List<AppFeature> getAllByIdList(List<String> idList) {
        Session session = getCurrentSession();
        Criteria criteria = session.createCriteria(AppFeature.class);
        criteria.add(Restrictions.in("id", idList));
        return criteria.list();
    }
}
