package com.yihu.hos.app.model;

import org.apache.commons.lang3.StringUtils;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * APP对象。
 *
 * @author Sand
 * @version 1.0
 * @created 03_8月_2015 16:53:21
 */

@Entity
@Table(name = "apps")
@Access(value = AccessType.FIELD)
public class App {
    @Id
    @GeneratedValue(generator = "Generator")
    @GenericGenerator(name = "Generator", strategy = "assigned")
    @Column(name = "id", unique = true, nullable = false)
    private String id;

    @Column(name = "name", nullable = true)
    private String name;

    @Column(name = "secret", nullable = true)
    private String secret;

    @Column(name = "url", nullable = true)
    private String url;

    @Column(name = "out_url", nullable = true)
    private String outUrl;

    @Column(name = "creator", nullable = true)
    private String creator;

    @Column(name = "auditor", nullable = true)
    private String auditor;

    @Column(name = "create_time", nullable = true)
    private Date createTime;

    @Column(name = "audit_time", nullable = true)
    private Date auditTime;

    @Column(name = "catalog", nullable = true)
    private String catalog;

    @Column(name = "status", nullable = true)
    private String status;

    @Column(name = "description", nullable = true)
    private String description;

    @Column(name = "tags", nullable = true)
    private String tags;

    @Column(name = "org", nullable = true)
    private String org;

    @Column(name = "code", nullable = true)
    private String code;

    @Column(name = "source_type", nullable = true)
    private int sourceType;

    @Column(name = "icon", nullable = true)
    private String icon;

    @Column(name = "release_flag", nullable = true)
    private int releaseFlag;

    @Column(name = "manage_type")
    private String manageType; // 管理类型，dictName=""

    public App() {
    }

    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }

    public String getSecret() {
        return secret;
    }
    public void setSecret(String secret) {
        this.secret = secret;
    }

    public String getUrl() {
        return url;
    }
    public void setUrl(String url) {
        this.url = url;
    }

    public String getOutUrl() {
        return outUrl;
    }
    public void setOutUrl(String outUrl) {
        this.outUrl = outUrl;
    }

    public String getCreator() {
        return creator;
    }
    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getAuditor() {
        return auditor;
    }
    public void setAuditor(String auditor) {
        this.auditor = auditor;
    }

    public Date getCreateTime() {
        return createTime;
    }
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getAuditTime() {
        return auditTime;
    }
    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public String getCatalog() {
        return catalog;
    }
    public void setCatalog(String catalog) {
        this.catalog = catalog;
    }

    public String getStatus() {
        return status;
    }
    public void setStatus(String status) {
        this.status = status;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public List<String> getTags() {
        List<String> list = new ArrayList<>();
        if (StringUtils.isEmpty(tags)) {
        } else {
            String[] arr = tags.split(";|；");
            list = Arrays.asList(arr);
        }
        return list;
    }
    public void setTags(List<String> tags) {
        if (tags.size() > 0) {
            this.tags = StringUtils.join(tags.toArray(), ";");
        } else {
            this.tags = "";
        }
    }

    public String getOrg() {
        return org;
    }
    public void setOrg(String org) {
        this.org = org;
    }


    public String getCode() {
        return code;
    }
    public void setCode(String code) {
        this.code = code;
    }

    public int getSourceType() {
        return sourceType;
    }
    public void setSourceType(int sourceType) {
        this.sourceType = sourceType;
    }

    public String getIcon() {
        return icon;
    }
    public void setIcon(String icon) {
        this.icon = icon;
    }

    public int getReleaseFlag() {
        return releaseFlag;
    }
    public void setReleaseFlag(int releaseFlag) {
        this.releaseFlag = releaseFlag;
    }

    public String getManageType() {
        return manageType;
    }
    public void setManageType(String manageType) {
        this.manageType = manageType;
    }
}