package com.yihu.hos.app.model;


import javax.persistence.*;

/**
 * APP_api对象。
 *
 * @author linzhuo
 * @version 1.0
 * @created 2016年7月7日17:45:30
 */

@Entity
@Table(name = "apps_api")
public class AppApi {

    private Integer id;
    private String appId;
    private String name;
    private String description;
    private String type;
    private String typeName;
    private String method;
    private String protocol;
    private String version;
    private Integer parentId;
    private String parameterDemo;
    private String activityType;
    private String responseDemo;
    private String openLevel;
    private String openLevelName;
    private String auditLevel;
    private String auditLevelName;
    private String methodName;

    private String microServiceUri;
    private String msMethodName;
    private String microServiceName;

    private Integer healthReportType;//健康监控(0为拉取,1推送)
    private String healthEndpoint;//健康监控端点地址


    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }
    @Column(name = "app_id", nullable = true)
    public String getAppId() {
        return appId;
    }

    public void setAppId(String appId) {
        this.appId = appId;
    }
    @Column(name = "name", nullable = true)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    @Column(name = "description", nullable = true)
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
    @Column(name = "type", nullable = true)
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
    @Column(name = "method", nullable = true)
    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }
    @Column(name = "protocol", nullable = true)
    public String getProtocol() {
        return protocol;
    }

    public void setProtocol(String protocol) {
        this.protocol = protocol;
    }
    @Column(name = "version", nullable = true)
    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    @Column(name = "parent_id", nullable = true)
    public Integer getParentId() {
        return parentId;
    }

    public void setParentId(Integer parentId) {
        this.parentId = parentId;
    }
    @Column(name = "parameter_demo", nullable = true)
    public String getParameterDemo() {
        return parameterDemo;
    }

    public void setParameterDemo(String parameterDemo) {
        this.parameterDemo = parameterDemo;
    }
    @Column(name = "activity_type", nullable = true)
    public String getActivityType() {
        return activityType;
    }

    public void setActivityType(String activityType) {
        this.activityType = activityType;
    }

    @Column(name = "response_demo", nullable = true)
    public String getResponseDemo() {
        return responseDemo;
    }

    public void setResponseDemo(String responseDemo) {
        this.responseDemo = responseDemo;
    }
    @Column(name = "open_level", nullable = true)
    public String getOpenLevel() {
        return openLevel;
    }

    public void setOpenLevel(String openLevel) {
        this.openLevel = openLevel;
    }

    @Column(name = "audit_level", nullable = true)
    public String getAuditLevel() {
        return auditLevel;
    }

    public void setAuditLevel(String auditLevel) {
        this.auditLevel = auditLevel;
    }

    @Column(name = "method_name", nullable = true)
    public String getMethodName() {
        return methodName;
    }

    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    @Column(name = "micro_service_url", nullable = true)
    public String getMicroServiceUri() {
        return microServiceUri;
    }

    public void setMicroServiceUri(String microServiceUri) {
        this.microServiceUri = microServiceUri;
    }

    @Column(name = "ms_method_name", nullable = true)
    public String getMsMethodName() {
        return msMethodName;
    }

    public void setMsMethodName(String msMethodName) {
        this.msMethodName = msMethodName;
    }

    @Column(name = "micro_service_name", nullable = true)
    public String getMicroServiceName() {
        return microServiceName;
    }

    public void setMicroServiceName(String microServiceName) {
        this.microServiceName = microServiceName;
    }

    @Transient
    public String getOpenLevelName() {
        return openLevelName;
    }

    public void setOpenLevelName(String openLevelName) {
        this.openLevelName = openLevelName;
    }

    @Transient
    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    @Transient
    public String getAuditLevelName() {
        return auditLevelName;
    }

    public void setAuditLevelName(String auditLevelName) {
        this.auditLevelName = auditLevelName;
    }

    @Column(name = "health_report_type", nullable = true)
    public Integer getHealthReportType() {
        return healthReportType;
    }

    public void setHealthReportType(Integer healthReportType) {
        this.healthReportType = healthReportType;
    }

    @Column(name = "health_endpoint", nullable = true)
    public String getHealthEndpoint() {
        return healthEndpoint;
    }

    public void setHealthEndpoint(String healthEndpoint) {
        this.healthEndpoint = healthEndpoint;
    }
}