package com.yihu.hos.app.service;

import com.yihu.hos.app.dao.AppApiParameterDao;
import com.yihu.hos.app.model.AppApiParameter;
import com.yihu.hos.core.log.Logger;
import com.yihu.hos.core.log.LoggerFactory;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by chenweida on 2016/1/21.
 */

@Service
public class AppApiParameterService extends BaseService<AppApiParameter>{

    static final Logger logger = LoggerFactory.getLogger(AppApiParameterService.class);

    @Autowired
    private AppApiParameterDao appApiParameterDao;

    @Transactional
    public AppApiParameter create(AppApiParameter obj) throws Exception {
        appApiParameterDao.saveEntity(obj);
        return obj;
    }

    public AppApiParameter getById(Integer id) throws Exception {
        return appApiParameterDao.getEntity(AppApiParameter.class, id);
    }

    @Transactional
    public void delete(Integer id) throws Exception {
        AppApiParameter obj = appApiParameterDao.getEntity(AppApiParameter.class, id);
        appApiParameterDao.deleteEntity(obj);
    }


    @Transactional
    public AppApiParameter update(AppApiParameter obj) throws Exception {
        appApiParameterDao.updateEntity(obj);
        return obj;
    }
}
