package com.yihu.hos.app.service;

import com.yihu.hos.app.dao.AppApiResponseDao;
import com.yihu.hos.app.model.AppApiResponse;
import com.yihu.hos.core.log.Logger;
import com.yihu.hos.core.log.LoggerFactory;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by chenweida on 2016/1/21.
 */

@Service
public class AppApiResponseService extends BaseService<AppApiResponse>{

    static final Logger logger = LoggerFactory.getLogger(AppApiResponseService.class);

    @Autowired
    private AppApiResponseDao appApiResponseDao;

    @Transactional
    public AppApiResponse create(AppApiResponse obj) throws Exception {
        appApiResponseDao.saveEntity(obj);
        return obj;
    }

    public AppApiResponse getById(Integer id) throws Exception {
        return appApiResponseDao.getEntity(AppApiResponse.class, id);
    }

    @Transactional
    public void delete(Integer id) throws Exception {
        AppApiResponse obj = appApiResponseDao.getEntity(AppApiResponse.class, id);
        appApiResponseDao.deleteEntity(obj);
    }


    @Transactional
    public AppApiResponse update(AppApiResponse obj) throws Exception {
        appApiResponseDao.updateEntity(obj);
        return obj;
    }
}
