package com.yihu.hos.common.controller;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.hos.web.framework.constant.ErrorCode;
import com.yihu.hos.web.framework.exception.EsbApiException;

import java.io.IOException;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;

/**
 * @author lincl
 * @version 1.0
 * @created 2016/2/4
 */
public class ExtendEndPoint<T>  extends EnvelopRestEndPoint {

    protected Long[] strToLongArr(String str){
        if(str==null || str.trim().length()==0)
            return new Long[0];
        return strArrToLongArr(str.split(","));
    }

    protected Integer[] strToIntegergArr(String str){
        if(str==null || str.trim().length()==0)
            return new Integer[0];
        return strArrToIntegerArr(str.split(","));
    }

    protected Integer[] strArrToIntegerArr(String[] strArr){

        Integer[] rs = new Integer[strArr.length];
        for (int i=0; i< strArr.length; i++){
            rs[i] = Integer.valueOf(strArr[i]);
        }
        return rs;
    }

    protected Long[] strArrToLongArr(String[] strArr){

        Long[] rs = new Long[strArr.length];
        for (int i=0; i< strArr.length; i++){
            rs[i] = Long.valueOf(strArr[i]);
        }
        return rs;
    }
    protected <T> T jsonToObj(String json ,Class<T> clz) throws IOException {
        ObjectMapper objectMapper = new ObjectMapper();
        return objectMapper.readValue(json, clz);
    }

    protected T getModel(Object o){
        return (T) convertToModel(o, getModelClass());
    }

    public Class getModelClass() {
        Type genType = this.getClass().getGenericSuperclass();
        Type[] parameters = ((ParameterizedType) genType).getActualTypeArguments();
        return (Class) parameters[0];
    }

    /*******************************************************************************************/
    /****************    以下是错误返回信息方法              **********************************/
    /*******************************************************************************************/

    protected EsbApiException errSystem(){
        return new EsbApiException(ErrorCode.SystemError, "系统出错！");
    }

    protected EsbApiException errParm(){
        return new EsbApiException(ErrorCode.InvalidParameter, "参数解析错误！");
    }

    protected EsbApiException errMissCode(){
        return errMissParm("代码");
    }

    protected EsbApiException errMissId(){
        return errMissParm("编号");
    }

    protected EsbApiException errRepeatCode(){
        return new EsbApiException(ErrorCode.RepeatCode);
    }

    protected EsbApiException errMissParm(String msg){
        return new EsbApiException(ErrorCode.MissParameter, msg);
    }

    protected EsbApiException errNotFound(String objName, Object id){
        return new EsbApiException(ErrorCode.NotFoundObj, objName, String.valueOf(id));
    }

    protected EsbApiException errMissVersion(){
        return new EsbApiException(ErrorCode.MissVersion, "版本号不能为空！");
    }
}
