package com.yihu.hos.jwt.secruity;


import com.yihu.hos.system.entity.SystemRole;
import com.yihu.hos.system.model.SystemUser;
import com.yihu.hos.system.service.SystemRoleService;
import com.yihu.hos.system.service.UserManager;
import com.yihu.hos.web.framework.constant.ContextAttributes;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service
public class JwtUserDetailsServiceImpl implements UserDetailsService {

    @Resource(name = UserManager.BEAN_ID)
    private UserManager userManager;

    @Autowired
    private SystemRoleService systemRoleService;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        SystemUser user = userManager.getUserByLoginCode(username);
        SystemRole systemRole = null;

        try {
            systemRole = systemRoleService.getRoleByCode(ContextAttributes.ROLE_USER);
            if (systemRole == null){
                systemRole =  new SystemRole();
                //不存在普通用户角色时，添加用户角色
                systemRole.setCode(ContextAttributes.ROLE_USER);
                systemRole.setName("普通用户");
                systemRole.setValid("true");
                systemRoleService.addRole(systemRole);
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

        if (user == null) {
            throw new UsernameNotFoundException(String.format("No user found with username '%s'.", username));
        } else {
            if (systemRole!=null){
                List<String> roles = new ArrayList<>();
                roles.add(systemRole.getCode());
                user.setRoles(roles);
            }

            JwtUser jwtUser = JwtUserFactory.create(user);
            return jwtUser;
        }
    }
}
