package com.yihu.hos.qc.dao;

import com.yihu.hos.qc.model.RuleModel;
import com.yihu.hos.web.framework.dao.SQLGeneralDAO;
import com.yihu.hos.web.framework.model.Result;
import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * @author CD
 * @vsrsion 1.0
 * Created at 2017/05/05.
 */
@Repository("ruleDao")
public class RuleDao extends SQLGeneralDAO {
    public static final String BEAN_ID = "ruleDao";

    public Result getRuleList(Map<String, Object> params) throws Exception {
        StringBuilder sb = new StringBuilder("from RuleModel r where 1=1 ");
        Object name = params.get("name");
        if (!StringUtils.isEmpty(name)) {
            sb.append(" and r.name like '%" + name + "%'");
        }
        String page = (String)params.get("page");
        String rows = (String)params.get("rows");
        if(StringUtils.isEmpty(page) || StringUtils.isEmpty(rows)){
            return super.getDataGridResult(sb.toString(), null,null);
        }
        return super.getDataGridResult(sb.toString(), Integer.valueOf(page), Integer.valueOf(rows));

    }

    public List<RuleModel> getRuleList(String name) throws Exception {
        StringBuilder sb = new StringBuilder("from RuleModel r where 1=1 ");
        if (!StringUtils.isEmpty(name)) {
            sb.append(" and r.name like '%" + name + "%'");
        }
        return (List<RuleModel>) super.hibernateTemplate.getSessionFactory().getCurrentSession().createQuery(sb.toString());
    }

    public List<RuleModel> getAllByIdList(List<String> idList) {
        Session session = getCurrentSession();
        Criteria criteria = session.createCriteria(RuleModel.class);
        criteria.add(Restrictions.in("id", idList));
        return criteria.list();
    }

    public RuleModel getByRule(String rule) {
        Session session = getCurrentSession();
        Criteria criteria = session.createCriteria(RuleModel.class);
        criteria.add(Restrictions.eq("rule", rule));
        List<RuleModel> ruleModels = criteria.list();
        if (ruleModels == null || ruleModels.size() == 0) {
            return null;
        }
        
        return ruleModels.get(0);
    }

    public RuleModel getByCode(String code) {
        RuleModel ruleModel = new RuleModel();
        if (!StringUtils.isEmpty(code)) {
            Session session = getCurrentSession();
            Criteria criteria = session.createCriteria(RuleModel.class);
            criteria.add(Restrictions.eq("code", code));
            ruleModel = (RuleModel) criteria.uniqueResult();
        }
        return ruleModel;
    }

    public List<RuleModel> getByRuleMethod(String ruleMethod) {
        Session session = getCurrentSession();
        Criteria criteria = session.createCriteria(RuleModel.class);
        criteria.add(Restrictions.eq("ruleMethod", ruleMethod));
        List<RuleModel> ruleModels = criteria.list();
        return ruleModels;
    }

}
