package com.yihu.hos.qc.model;

import org.hibernate.annotations.Formula;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;

/**
 *
 * 质控表
 *
 * @author CD
 * @vsrsion 1.0
 * Created at 2017/05/05.
 */
@Entity
@Table(name = "qc_rule")
public class RuleModel implements java.io.Serializable {

    private String id;
    private String name; // 名称
    private String code; // 编码
    private String type; // 分类
    private String describe; // 描述
    private String rule; // 规则校验地址
    private String error_code; // 统一错误代码
    private String ruleMethod; // 质控规则反射方法

    // 临时属性
    private String typeName; // 分类名称
    private String errorCodeName; // 统一错误代码名称

    @Id
    @GeneratedValue(generator = "generator")
    @GenericGenerator(name = "generator", strategy = "uuid")
    @Column(name = "id")
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Column(name = "name", length = 255, nullable = true)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "code", length = 50, nullable = false)
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "type", length = 20, nullable = false)
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    @Column(name = "description", length = 1000, nullable = false)
    public String getDescribe() {
        return describe;
    }

    public void setDescribe(String describe) {
        this.describe = describe;
    }

    @Column(name = "rule", length = 255, nullable = false)
    public String getRule() {
        return rule;
    }

    public void setRule(String rule) {
        this.rule = rule;
    }

    @Column(name = "error_code", length = 50, nullable = true)
    public String getError_code() {
        return error_code;
    }

    public void setError_code(String error_code) {
        this.error_code = error_code;
    }

    @Formula("( SELECT b.value FROM qc_rule a LEFT JOIN system_dict b ON b.code = a.type WHERE a.id = id )")
    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    @Formula("( SELECT b.value FROM qc_rule a LEFT JOIN system_dict b ON b.code = a.error_code WHERE a.id = id )")
    public String getErrorCodeName() {
        return errorCodeName;
    }

    public void setErrorCodeName(String errorCodeName) {
        this.errorCodeName = errorCodeName;
    }

    @Column(name = "rule_method", length = 255, nullable = false)
    public String getRuleMethod() {
        return ruleMethod;
    }

    public void setRuleMethod(String ruleMethod) {
        this.ruleMethod = ruleMethod;
    }
}