package com.yihu.hos.redis.schema.adapter;

import com.yihu.ehr.redis.schema.KeySchema;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Component;

/**
 *  Created by hzp on 2017.04.25
 */
@Component
public class AdapterMetaDataKeySchema extends KeySchema {

    private String AdapterMetaDataCode = "adapter_metadata_code";
    private String AdapterMetaDataName = "adapter_metadata_name";
    private String StdMetaDataName = "std_metadata_name";

    public void delete(String tableName) {
        redisClient.delete(makeKey(tableName , "*", "*"));
    }

    public void setAdapterMetaDataCode(String tableName, String stddataSetCode, String stdMetadataCode,String value) {
        if (StringUtils.isNotEmpty(value)) {
            redisClient.set(makeKey(tableName, stddataSetCode + "." + stdMetadataCode, AdapterMetaDataCode), value);
        }
    }

    public String getAdapterMetaDataCode(String tableName, String stdDatasetCode, String stdMetadataCode) {
        return redisClient.get(makeKey(tableName, stdDatasetCode + "." + stdMetadataCode, AdapterMetaDataCode));
    }

    public void setAdapterMetaDataName(String tableName, String stddataSetCode, String stdMetadataCode, String value) {
        if (StringUtils.isNotEmpty(value)) {
            redisClient.set(makeKey(tableName, stddataSetCode + "." + stdMetadataCode, AdapterMetaDataName), value);
        }
    }

    public String getAdapterMetaDataName(String tableName, String stdDatasetCode, String stdMetadataCode) {
        return redisClient.get(makeKey(tableName, stdDatasetCode + "." + stdMetadataCode, AdapterMetaDataName));
    }


    public void setStdMetaDataName(String tableName, String stddataSetCode, String stdMetadataCode, String value) {
        if (StringUtils.isNotEmpty(value)) {
            redisClient.set(makeKey(tableName, stddataSetCode + "." + stdMetadataCode, StdMetaDataName), value);
        }
    }

    public String getStdMetaDataName(String tableName, String stdDatasetCode, String stdMetadataCode) {
        return redisClient.get(makeKey(tableName, stdDatasetCode + "." + stdMetadataCode, StdMetaDataName));
    }

}
