package com.yihu.hos.specialdict.service;


import com.yihu.hos.core.datatype.CollectionUtil;
import com.yihu.hos.specialdict.model.DrugDict;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

/**
 * 用户公私钥管理
 *
 * @author CWS
 * @version 1.0
 * @created 02-6月-2015 17:38:05
 */
@Transactional
@Service
public class DrugDictService extends BaseService<DrugDict>{


    @Autowired
    private Icd10DrugRelationService icd10DrugRelationService;

    public boolean isCodeExist(String code) throws ParseException {
        DrugDict drugDict = findByCode(code);
        return drugDict != null;
    }

    public boolean isNameExist(String name) throws ParseException {
        DrugDict drugDict = findByName(name);
        return drugDict != null;
    }

    public DrugDict createDict(DrugDict dict) throws Exception {
        dict.setName(dict.getName());
        saveEntity(dict);
        return dict;
    }

    public boolean isUsage(long id) throws ParseException {
        boolean result = (icd10DrugRelationService.findByDrugId(id) != null);
        return result;
    }

    public List<DrugDict> getDrugDictByIds(long[] ids) {
        if(ids==null){
            return null;
        }
        List<Long> longs = new ArrayList<Long>();
        for(long id:ids){
            longs.add(id);
        }
        return getListByIdList(DrugDict.class,"drug_dict","id",longs);
    }

    public DrugDict findByCode(String code) throws ParseException {
        List search = search("code=" + code);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return (DrugDict) search.get(0);
    }
    public DrugDict findByName(String name) throws ParseException {
        List search = search("name=" + name);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return (DrugDict) search.get(0);
    }

}