package com.yihu.hos.specialdict.service;


import com.yihu.hos.core.datatype.CollectionUtil;
import com.yihu.hos.specialdict.model.Icd10Dict;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;


/**
 * 用户公私钥管理
 *
 * @author CWS
 * @version 1.0
 * @created 02-6月-2015 17:38:05
 */
@Transactional
@Service
public class Icd10DictService extends BaseService<Icd10Dict>{
    @Autowired
    private Icd10HpRelationService icd10HpRelationService;
    @Autowired
    private Icd10DrugRelationService icd10DrugRelationService;
    @Autowired
    private Icd10IndicatorRelationService icd10IndicatorRelationService;

    public boolean isCodeExist(String code) throws ParseException {
        long count = getCount("code=" + code);
        if(count>0){
            return true;
        }
        return false;
    }

    public boolean isNameExist(String name) throws ParseException {
        long count = getCount("name=" + name);
        if(count>0){
            return true;
        }
        return false;
    }

    public Icd10Dict createDict(Icd10Dict dict) throws Exception {
        dict.setName(dict.getName());
        Icd10Dict icd10Dict = saveEntity(dict);
        return icd10Dict;
    }

    public boolean isUsage(long id) throws ParseException {
        boolean result = ((icd10HpRelationService.findByIcd10Id(id) != null)||(icd10DrugRelationService.findByIcd10Id(id) != null)||(icd10IndicatorRelationService.findByIcd10Id(id) != null));
        return result;
    }

    public List<Icd10Dict> findByIds(long[] ids) {
        if(ids==null){
            return null;
        }
        List<Long> longs = new ArrayList<Long>();
        for(long id:ids){
            longs.add(id);
        }
        return getListByIdList(Icd10Dict.class,"icd10_dict","id",longs);
    }

    public Icd10Dict findByCode(String code) throws ParseException {
        List icd10Dicts = search("code=" + code);
        if(CollectionUtil.isEmpty(icd10Dicts)){
            return null;
        }
        return (Icd10Dict) icd10Dicts.get(0);
    }
}