package com.yihu.hos.specialdict.service;


import com.yihu.hos.core.datatype.CollectionUtil;
import com.yihu.hos.specialdict.model.Icd10HpRelation;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.hibernate.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.util.List;

/**
 * 用户公私钥管理
 *
 * @author CWS
 * @version 1.0
 * @created 02-6月-2015 17:38:05
 */
@Transactional
@Service
public class Icd10HpRelationService extends BaseService<Icd10HpRelation>{

    public boolean isExist(long icd10Id,long hpId) throws ParseException {
        Icd10HpRelation icd10HpRelation = findByIcd10IdAndHpId(icd10Id,hpId);
        return icd10HpRelation != null;
    }

    public List<Icd10HpRelation> getHpIcd10RelationListByHpId(long hpId) throws ParseException {
        List<Icd10HpRelation> icd10HpRelationList = findByHpId(hpId);
        if(CollectionUtil.isEmpty(icd10HpRelationList)){
            return null;
        }
        return icd10HpRelationList;
    }

    public boolean isUsage(long icd10Id) throws ParseException {
        List<Icd10HpRelation> icd10HpRelationList = findByIcd10Id(icd10Id);
        if(CollectionUtil.isEmpty(icd10HpRelationList)){
            return false;
        }
        return true;
    }

    /**
     * 根据ID删除标准来源
     *
     * @param ids
     */
    public int delete(Object[] ids) {
        String hql = "DELETE FROM Icd10HpRelation WHERE id in (:ids)";
        Query query = getCurrentSession().createQuery(hql);
        query.setParameterList("ids", ids);
        return query.executeUpdate();
    }

    public int delete(List<Long> ids){
        Long[] idsArray = new Long[ids.size()];
        ids.toArray(idsArray);
        String hql = "DELETE FROM Icd10HpRelation WHERE id in (:ids)";
        Query query = getCurrentSession().createQuery(hql);
        query.setParameterList("ids", idsArray);
        return query.executeUpdate();
    }

    public List<Icd10HpRelation> getHpIcd10RelationByHpId(long hpId) throws ParseException {
        return findByHpId(hpId);
    }

    public List<Icd10HpRelation> findByIcd10Id(long icd10Id) throws ParseException {
        List search = search("icd10Id=" + icd10Id);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return search;
    }

    public List<Icd10HpRelation> findByHpId(long hpId) throws ParseException {
        List search = search("hpId=" + hpId);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return search;
    }

    public Icd10HpRelation findByIcd10IdAndHpId(long icd10Id, long hpId) throws ParseException {
        List search = search("icd10Id=" + icd10Id+"&hpId="+hpId);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return (Icd10HpRelation) search.get(0);
    }

    List<Icd10HpRelation> findAllIcd10HpRelation() throws ParseException {
        List search = search("");
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return search;
    }
}