package com.yihu.hos.specialdict.service;


import com.yihu.hos.core.datatype.CollectionUtil;
import com.yihu.hos.specialdict.model.IndicatorsDict;
import com.yihu.hos.web.framework.baseservice.BaseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

/**
 * 用户公私钥管理
 *
 * @author CWS
 * @version 1.0
 * @created 02-6月-2015 17:38:05
 */
@Transactional
@Service
public class IndicatorsDictService extends BaseService<IndicatorsDict>{

    @Autowired
    private Icd10IndicatorRelationService icd10IndicatorRelationDao;


    public boolean isCodeExist(String code) throws ParseException {
        IndicatorsDict indicatorsDict = findByCode(code);
        return indicatorsDict != null;
    }


    public IndicatorsDict findByCode(String code) throws ParseException {
        List search = search("code=" + code);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return (IndicatorsDict) search.get(0);
    }

    public boolean isNameExist(String name) throws ParseException {
        IndicatorsDict indicatorsDict = findByName(name);
        return indicatorsDict != null;
    }

    public IndicatorsDict findByName(String name) throws ParseException {
        List search = search("name=" + name);
        if(CollectionUtil.isEmpty(search)){
            return null;
        }
        return (IndicatorsDict) search.get(0);
    }

    public boolean isUsage(long id) throws ParseException {
        boolean result = (icd10IndicatorRelationDao.findByIndicatorId(id) != null);
        return result;
    }

    public IndicatorsDict createDict(IndicatorsDict dict) throws Exception {
        dict.setName(dict.getName());
        saveEntity(dict);
        return dict;
    }


    public List<IndicatorsDict> getIndicatorsDictByIds(long[] ids) {
        if(ids==null){
            return null;
        }
        List<Long> longs = new ArrayList<>();
        for(long id:ids){
            longs.add(id);
        }
        return getListByIdList(IndicatorsDict.class,"indicators_dict","id",longs);
    }
}