package com.yihu.hos.standard.match.dictionary;


import com.yihu.hos.standard.dao.IStdDictionaryModelDao;
import com.yihu.hos.standard.model.adapter.AdapterDictEntryModel;
import com.yihu.hos.standard.model.standard.StdDictionaryEntryModel;
import com.yihu.hos.standard.model.standard.StdDictionaryModel;
import com.yihu.hos.standard.service.adapter.AdapterDictEntryService;
import com.yihu.hos.standard.util.LikeHashMap;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.Map;

/**
 * Created by Administrator on 2016/7/4.
 */
@Scope("prototype")
@Component("dictitemStandardNameStrategy")
public class DictitemStandardNameStrategy {

    private AdapterDictEntryService adapterDictEntryService;

    private IStdDictionaryModelDao stdDictionaryDao;

    public IStdDictionaryModelDao getStdDictionaryDao() {
        return stdDictionaryDao;
    }

    private String schemaName;

    public void setStdDictionaryDao(IStdDictionaryModelDao stdDictionaryDao) {
        this.stdDictionaryDao = stdDictionaryDao;
    }

    public AdapterDictEntryService getAdapterDictEntryService() {
        return adapterDictEntryService;
    }

    public void setAdapterDictEntryService(AdapterDictEntryService adapterDictEntryService) {
        this.adapterDictEntryService = adapterDictEntryService;
    }

    public DictitemStandardNameStrategy(AdapterDictEntryService adapterDictEntryService) {

        this.adapterDictEntryService = adapterDictEntryService;
    }

    public String getSchemaName() {
        return schemaName;
    }

    public void setSchemaName(String schemaName) {
        this.schemaName = schemaName;
    }

    private static LikeHashMap<String,StdDictionaryEntryModel> nameMap=new LikeHashMap<String,StdDictionaryEntryModel>();//机构字典项值的map


    public DictitemStandardNameStrategy() {

    }


    @Transactional
    public boolean match(AdapterDictEntryModel adapterDictEntryModel, String version,String std_version) throws Exception {
        StdDictionaryModel dictionary = stdDictionaryDao.getDictionaryName(schemaName,std_version, adapterDictEntryModel.getStdDictId());//查找目标字典

        StdDictionaryEntryModel orgDictItem = nameMap.get(adapterDictEntryModel.getStdEntryCode()+"_"+adapterDictEntryModel.getStdEntryValue()+ "_" + dictionary.getName(), true);
        if (orgDictItem != null ) {
            adapterDictEntryService.saveAdapt(schemaName,adapterDictEntryModel, orgDictItem, version,"2");//字典名和字典项名字一样,即为完全匹配
            return true;
        }
        orgDictItem = nameMap.get(adapterDictEntryModel.getStdEntryCode()+"_"+adapterDictEntryModel.getStdEntryValue()+ "_" , true);//疑似适配,//根据字典项的code和名称
        if (orgDictItem != null ) {
            adapterDictEntryService.saveAdapt(schemaName,adapterDictEntryModel, orgDictItem, version,"1");//只匹配字典项code ,为疑似匹配--->>匹配度已经很高了,但是仍然设置为疑似适配,方便校验
            return true;
        }
        orgDictItem = nameMap.get("_"+adapterDictEntryModel.getStdEntryValue()+ "_" , true);//疑似适配 ,//只根据字典项的value
        if (orgDictItem != null ) {
            adapterDictEntryService.saveAdapt(schemaName,adapterDictEntryModel, orgDictItem, version,"1");//只匹配字典项 名字,为疑似匹配--->>匹配度较低
            return true;
        }
        if(adapterDictEntryModel.getStdEntryCode().length()>=5){// (code如果复杂的情况时(icd10等字典那些),匹配度也很高了,否则匹配度极低)
            orgDictItem = nameMap.get(adapterDictEntryModel.getStdEntryCode()+ "_" , true);//疑似适配,//只根据字典项的code
            if (orgDictItem != null ) {
                adapterDictEntryService.saveAdapt(schemaName,adapterDictEntryModel, orgDictItem, version,"1");//只匹配字典项code ,为疑似匹配
                return true;
            }
        }
        return false;
    }


    public static Map<String, StdDictionaryEntryModel> getNameMap() {
        return nameMap;
    }

    public static void setNameMap(LikeHashMap<String, StdDictionaryEntryModel> nameMap) {
        DictitemStandardNameStrategy.nameMap = nameMap;
    }
}
