package com.yihu.hos.standard.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.hos.web.framework.model.Result;
import org.springframework.beans.factory.annotation.Value;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.Date;
import java.util.Objects;

/**
 * @author AndyCai
 * @version 1.0
 * @created 01-9月-2015 16:54:17
 */
@MappedSuperclass
public class BaseCDADocument extends Result implements Serializable {
    @Transient
    @Value("${admin-region}")
    short adminRegion;

    @Id
    @Column(name = "id", unique = true, nullable = false)
    private String id;
    @Column(name = "code", unique = false, nullable = false)
    private String code;
    @Column(name = "name", unique = false, nullable = false)
    private String name;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "create_date", unique = false, nullable = false)
    private Date createDate;
    @Column(name = "create_user", unique = false, nullable = false)
    private String createUser;
    @Column(name = "description", unique = false, nullable = true)
    private String description;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "update_date", unique = false, nullable = true)
    private Date updateDate;
    @Column(name = "update_user", unique = false, nullable = true)
    private String updateUser;
    @Transient
    private String versionCode;
    @Column(name = "type", unique = false, nullable = false)
    private String type;
    @Column(name = "print_out", unique = false, nullable = true)
    private String printOut;
    @Column(name = "schema_path", unique = false, nullable = true)
    private String schema;
    @Column(name = "source_id", unique = false, nullable = false)
    private String sourceId;
    @Column(name = "hash", unique = false, nullable = true)
    private int hashCode;
    @Column(name = "file_group", unique = false, nullable = true)
    private String fileGroup;
    @Transient
    private String staged;
    @Column(name="std_id")
    private Long standardId;           //标准ID
    @Column(name="std_version")
    private String stdVersion;


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public String getVersionCode() {
        return versionCode;
    }

    public void setVersionCode(String versionCode) {
        this.versionCode = versionCode;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getPrintOut() {
        return printOut;
    }

    public void setPrintOut(String printOut) {
        this.printOut = printOut;
    }

    public String getSchema() {
        return schema;
    }

    public void setSchema(String schema) {
        this.schema = schema;
    }

    public String getSourceId() {
        return sourceId;
    }

    public void setSourceId(String sourceId) {
        this.sourceId = sourceId;
    }

    public int getHashCode() {
        hashCode = Objects.hash(id, code, createDate, createUser, name, printOut, schema, sourceId);
        return hashCode;
    }

    public void setHashCode(int hashCode) {
        this.hashCode = hashCode;
    }

    public String getFileGroup() {
        return fileGroup;
    }

    public void setFileGroup(String fileGroup) {
        this.fileGroup = fileGroup;
    }

    public String getStaged() {
        return staged;
    }

    public void setStaged(String staged) {
        this.staged = staged;
    }

    public Long getStandardId() {
        return standardId;
    }

    public void setStandardId(Long standardId) {
        this.standardId = standardId;
    }

    public String getStdVersion() {
        return stdVersion;
    }

    public void setStdVersion(String stdVersion) {
        this.stdVersion = stdVersion;
    }
}