package com.yihu.hos.standard.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.Date;

/**
 * CDA类型
 *
 * @author AndyCai
 * @version 1.0
 * @created 11-12月-2015 15:52:22
 */
@Entity
@Table(name = "std_cda_type")
//@Access(value = AccessType.PROPERTY)
public class CDAType {

    @Id
    @GeneratedValue(generator = "Generator")
    @GenericGenerator(name = "Generator", strategy = "assigned")
    @Column(name = "id", unique = true, nullable = false)
    private String id;

    @Column(name = "code",  nullable = false)
    private String code;

    @Column(name = "name",  nullable = false)
    private String name;

    @Column(name = "parent_id",  nullable = true)
    private String parentId;

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    @Column(name = "create_date",  nullable = true)
    private Date createDate;

    @Column(name = "create_user",  nullable = true)
    private String createUser;

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    @Column(name = "update_date",  nullable = true)
    private Date updateDate;

    @Column(name = "update_user",  nullable = true)
    private String updateUser;

    @Column(name = "description",  nullable = true)
    private String description;

    public CDAType() {

    }


    public String getId() {
        return this.id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public void setCode(String code) {
        this.code = code;
    }
    public String getCode() {
        return this.code;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return this.name;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }
    public String getParentId() {
        return this.parentId;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }
    public Date getCreateDate() {
        return this.createDate;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }
    public String getCreateUser() {
        return this.createUser;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }
    public Date getUpdateDate() {
        return this.updateDate;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }
    public String getUpdateUser() {
        return this.updateUser;
    }

//    public CDAType getParentCdaType() {
//
////        XCDATypeManager xcdaTypeManager = ServiceFactory.getService(Services.CDATypeManager);
////        List<XCDAType> listType = xcdaTypeManager.getCdatypeInfoByIds(this.parentId);
////        if (listType.size() > 0) {
////            return (CDAType) listType.get(0);
////        }
//        return null;
//    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }
}