package com.yihu.hos.standard.model.adapter;

import com.yihu.hos.web.framework.model.Result;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import java.io.Serializable;

/**
 * Created by lingfeng on 2015/9/16.
 */
public class AdapterDictEntryModel extends Result implements Serializable {
    @Id
    @GeneratedValue(generator = "generator")
    @GenericGenerator(name = "generator", strategy = "increment")
    @Column(name = "id")
    private Long id;
    @Column(name = "scheme_id")
    private Long schemeId;
    @Column(name = "std_dict_id")
    private Long stdDictId;
    @Column(name = "std_entry_id")
    private Long stdEntryId;
    @Column(name = "std_entry_code")
    private String stdEntryCode;
    @Column(name = "std_entry_value")
    private String stdEntryValue;
    @Column(name = "adapter_dict_id")
    private Long adapterDictId;
    @Column(name = "adapter_entry_id")
    private Long adapterEntryId;
    @Column(name = "adapter_entry_code")
    private String adapterEntryCode;
    @Column(name = "adapter_entry_value")
    private String adapterEntryValue;
    @Column(name = "adapter_info")
    private String adapterInfo;
    @Column(name="is_clone")
    private Integer isClone; //0 不是克隆(默认)   1是克隆

    /**
     * 错误消息
     */
    public static AdapterDictEntryModel error(String message) {
        AdapterDictEntryModel re= new AdapterDictEntryModel();
        re.successFlg = false;
        re.message = message;
        return re;
    }

    public String getAdapterInfo() {
        return adapterInfo;
    }

    public void setAdapterInfo(String adapterInfo) {
        this.adapterInfo = adapterInfo;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSchemeId() {
        return schemeId;
    }

    public void setSchemeId(Long schemeId) {
        this.schemeId = schemeId;
    }

    public Long getStdDictId() {
        return stdDictId;
    }

    public void setStdDictId(Long stdDictId) {
        this.stdDictId = stdDictId;
    }

    public Long getStdEntryId() {
        return stdEntryId;
    }

    public void setStdEntryId(Long stdEntryId) {
        this.stdEntryId = stdEntryId;
    }

    public String getStdEntryCode() {
        return stdEntryCode;
    }

    public void setStdEntryCode(String stdEntryCode) {
        this.stdEntryCode = stdEntryCode;
    }

    public String getStdEntryValue() {
        return stdEntryValue;
    }

    public void setStdEntryValue(String stdEntryValue) {
        this.stdEntryValue = stdEntryValue;
    }

    public Long getAdapterDictId() {
        return adapterDictId;
    }

    public void setAdapterDictId(Long adapterDictId) {
        this.adapterDictId = adapterDictId;
    }

    public Long getAdapterEntryId() {
        return adapterEntryId;
    }

    public void setAdapterEntryId(Long adapterEntryId) {
        this.adapterEntryId = adapterEntryId;
    }

    public String getAdapterEntryCode() {
        return adapterEntryCode;
    }

    public void setAdapterEntryCode(String adapterEntryCode) {
        this.adapterEntryCode = adapterEntryCode;
    }

    public String getAdapterEntryValue() {
        return adapterEntryValue;
    }

    public void setAdapterEntryValue(String adapterEntryValue) {
        this.adapterEntryValue = adapterEntryValue;
    }

    public Integer getIsClone() {
        return isClone;
    }

    public void setIsClone(Integer isClone) {
        this.isClone = isClone;
    }
}
