package com.yihu.hos.standard.model.standard;

import com.yihu.hos.web.framework.model.Result;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.Objects;

/**
 * Created by wq on 2015/9/22.
 */
public class StdMetaDataModel extends Result implements Serializable {
    @Id
    @GenericGenerator(name = "generator", strategy = "increment")
    @Column(name = "id")
    private Long id;                    // 数据元ID

    @Column(name = "std_id")
    private Long standardId;           //标准ID

    @Column(name = "dataset_id")
    private Long dataSetId;             //数据集ID

    @Column(name = "inner_code")
    private String innerCode;           // 内部代码

    @Column(name = "code")
    private String code;                 // 标准元编码

    @Column(name = "name")
    private String name;                // 名称

    @Column(name = "type")
    private String type;                // 数据元数据类型

    @Column(name = "format")
    private String format;              // 表示格式

    @Column(name = "dict_id")
    private Long dictId;                //字典ID

    @Column(name = "definition")
    private String definition;          // 标准元定义, 即说明

    @Column(name = "nullable")
    private boolean nullable;           // 是否可为空

    @Column(name = "column_length")
    private String columnLength;         // 数据长度

    @Column(name = "column_type")
    private String columnType;          // 数据类型

    @Column(name = "column_name")
    private String columnName;          // 字段名

    @Column(name = "primary_key")
    private boolean primaryKey;         // 是否为主键

    @Column(name = "hash", unique = false, nullable = false)
    private Integer hashCode;
    @Column(name = "std_version")
    private String stdVersion;

    /************************/
    /**  Transient        ***/
    /************************/
    @Transient
    boolean isHbaseFullTextRetrieval;       // Hbase 全文检索字段
    @Transient
    boolean isHbasePrimaryKey;              // Hbase 主键字段
    @Transient
    private String dictName;
    @Transient
    private String dictCode;


    public Integer getHashCode() {
        hashCode = Objects.hash(dataSetId, dictId, code, definition, format, innerCode, name,
                type, columnLength, columnType, nullable, primaryKey);

        return hashCode;
    }

    public void setHashCode(Integer hashCode) {
        this.hashCode = hashCode;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getStandardId() {
        return standardId;
    }

    public void setStandardId(Long standardId) {
        this.standardId = standardId;
    }

    public Long getDataSetId() {
        return dataSetId;
    }

    public void setDataSetId(long dataSetId) {
        this.dataSetId = dataSetId;
    }

    public String getInnerCode() {
        return innerCode;
    }

    public void setInnerCode(String innerCode) {
        this.innerCode = innerCode;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    public Long getDictId() {
        return dictId;
    }

    public void setDictId(Long dictId) {
        this.dictId = dictId;
    }

    public String getDefinition() {
        return definition;
    }

    public void setDefinition(String definition) {
        this.definition = definition;
    }

    public boolean getNullable() {
        return nullable;
    }

    public void setNullable(boolean nullable) {
        this.nullable = nullable;
    }

    public String getColumnLength() {
        return columnLength;
    }

    public void setColumnLength(String columnLength) {
        this.columnLength = columnLength;
    }

    public String getColumnType() {
        return columnType;
    }

    public void setColumnType(String columnType) {
        this.columnType = columnType;
    }

    public String getColumnName() {
        return columnName;
    }

    public void setColumnName(String columnName) {
        this.columnName = columnName;
    }

    public boolean getPrimaryKey() {
        return primaryKey;
    }

    public void setPrimaryKey(boolean primaryKey) {
        this.primaryKey = primaryKey;
    }

    public boolean isHbaseFullTextRetrieval() {
        return isHbaseFullTextRetrieval;
    }

    public void setHbaseFullTextRetrieval(boolean hbaseFullTextRetrieval) {
        isHbaseFullTextRetrieval = hbaseFullTextRetrieval;
    }

    public boolean isHbasePrimaryKey() {
        return isHbasePrimaryKey;
    }

    public void setHbasePrimaryKey(boolean hbasePrimaryKey) {
        isHbasePrimaryKey = hbasePrimaryKey;
    }

    public String getDictName() {
        return dictName;
    }

    public void setDictName(String dictName) {
        this.dictName = dictName;
    }

    public String getDictCode() {
        return dictCode;
    }

    public void setDictCode(String dictCode) {
        this.dictCode = dictCode;
    }

    public boolean isNullable() {
        return nullable;
    }

    public boolean isPrimaryKey() {
        return primaryKey;
    }

    public String getStdVersion() {
        return stdVersion;
    }

    public void setStdVersion(String stdVersion) {
        this.stdVersion = stdVersion;
    }

    public void setDataSetId(Long dataSetId) {

        this.dataSetId = dataSetId;
    }
}
