package com.yihu.hos.standard.service.standard;

import com.yihu.hos.standard.model.standard.StdDictionaryEntryModel;
import com.yihu.hos.standard.model.standard.StdDictionaryModel;
import com.yihu.hos.standard.util.ExcelUtilBigData;
import com.yihu.hos.web.framework.dao.SQLGeneralDAO;
import com.yihu.hos.web.framework.model.standard.StandardVersion;
import org.springframework.util.StringUtils;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DictExcelUtil extends SQLGeneralDAO implements Runnable {

    private StdDictService stdDictService;
    private StdDictEntryService stdDictEntryService;
    private String version;
    private File file;
    private Long standardId;
    private String schema;
    public static Map<String, Integer> size = new HashMap<String, Integer>();//记录当前条数 key为version, value为已经导入的条数  当value=-1时,则程序运行时有异常
    public static Map<String, Integer> totle = new HashMap<String, Integer>();//记录总条数
    public static Map<String,String> error = new HashMap<String,String>();//记录错误信息 key为version, value为错误信息

    public DictExcelUtil(StdDictService stdDictService, StdDictEntryService stdDictEntryService, String version, File file, Long standardId, String schema) {
        this.stdDictService = stdDictService;
        this.stdDictEntryService = stdDictEntryService;
        this.version = version;
        this.file = file;
        this.standardId = standardId;
        this.schema = schema;
    }

    @Override
    public void run() {
        try{List<List<String[]>> list = null;
            try {
                list = ExcelUtilBigData.readerExcel(new FileInputStream(file), 6, 3);
                DictExcelUtil.totle.put(version,list.size());
                DictExcelUtil.size.put(version,0);
            } catch (Exception e) {
                DictExcelUtil.size.put(version,-1);
                DictExcelUtil.error.put(version,e.getMessage());
                e.printStackTrace();
                return;
            }
            System.out.println("共有"+list.size()+"个字典sheet");
            StandardVersion standardVersion = new StandardVersion(version);
            for (int i = 0; i < list.size(); i++) {
                List<String[]> l = list.get(i);
                //遍历sheet
                StdDictionaryModel stdeDict = new StdDictionaryModel();
                stdeDict.setStandardId(standardId);
                stdeDict.setCode(getNotNull(l.get(0)[1]));
                stdeDict.setName(getNotNull(l.get(1)[1]));

                String insertSql = null;
                try {
                    insertSql = stdDictService.getInsertSql(standardVersion,stdeDict,schema);
                } catch (IOException e) {
                    DictExcelUtil.size.put(version,-1);
                    DictExcelUtil.error.put(version,e.getMessage());
                    e.printStackTrace();
                    return;
                }
                stdDictService.getJdbcTemplate().execute(insertSql);
                Long id = stdDictService.getIdByCode(version, stdeDict.getCode(), schema);
                stdeDict.setId(id);
                List<String> sqls = new ArrayList<>();
                for (int row = 0; row < l.size(); row++) {
                    if (StringUtils.isEmpty(l.get(row)[4])) {
                        continue;
                    }
                    StdDictionaryEntryModel stdeDictItem = new StdDictionaryEntryModel();
                    stdeDictItem.setStandardId(standardId);
                    stdeDictItem.setDictId(stdeDict.getId());
                    stdeDictItem.setValue(getNotNull(l.get(row)[4]));
                    stdeDictItem.setCode(getNotNull(l.get(row)[3]));
                    stdeDictItem.setDesc(getNotNull(l.get(row)[5]));
                    //单条插入太慢了.....改成批量插入
                    //stdDictEntryService.add(standardVersion,stdeDictItem);
                    String sql = null;
                    try {
                        sql = stdDictEntryService.getInsertSql(standardVersion, stdeDictItem, schema);
                    } catch (IOException e) {
                        DictExcelUtil.size.put(version,-1);
                        DictExcelUtil.error.put(version,e.getMessage());
                        e.printStackTrace();
                        return;
                    }
                    sqls.add(sql);
                    if(sqls.size()==1000){
                        stdDictService.insertBatch(sqls);
                        sqls = new ArrayList<>();
                    }
                }
                if (sqls.size() > 0) {
                    stdDictService.insertBatch(sqls);
                }
                System.out.println("插入了第" + (i + 1) + "个字典sheet");
                DictExcelUtil.size.put(version,i+1);
            }

        }catch (Exception e){
            DictExcelUtil.size.put(version,-1);
            DictExcelUtil.error.put(version,e.getMessage());
            e.printStackTrace();
            return;
        }


    }

    private String getNotNull(Object obj) {
        if (!StringUtils.isEmpty(obj)) {
            return obj.toString().replace("\"", "");
        }
        return "";
    }
}