package com.yihu.hos.standard.service.standard;

import com.fasterxml.jackson.databind.JsonNode;
import com.yihu.hos.model.standard.MStdIndex;
import com.yihu.hos.standard.model.standard.StdDataSetModel;
import com.yihu.hos.standard.model.standard.StdIndex;
import com.yihu.hos.web.framework.dao.SQLGeneralDAO;
import com.yihu.hos.web.framework.model.standard.StandardVersion;
import com.yihu.hos.web.framework.util.sql.SqlCreator;
import org.hibernate.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import java.io.IOException;
import java.util.List;


@Transactional
@Service
public class StdIndexService extends SQLGeneralDAO {
    @Autowired
    private StdDatasetService stdDatasetService;

    public void save(String indexJson) throws Exception {
        MStdIndex mStdIndex = objectMapper.readValue(indexJson, MStdIndex.class);
        String version = mStdIndex.getVersion();
        Long stdDatasetId = mStdIndex.getStdDatasetId();
        //通过id查找stdDatasetCode
        StdDataSetModel stdDataSetModel = stdDatasetService.get(new StandardVersion(version), stdDatasetId);
        if(stdDataSetModel!=null){
            mStdIndex.setStdDatasetCode(stdDataSetModel.getCode());
        }else{
            throw new Exception("未找到数据集");
        }
        JsonNode jsonNode = objectMapper.readTree(objectMapper.writeValueAsString(mStdIndex));
        SqlCreator sqlCreator = new SqlCreator(StdIndex.class);
        String sql = sqlCreator.insertData("std_index_"+version, jsonNode);
        Query query = getExeuteQuery(sqlCreator, sql);
        query.executeUpdate();
    }

    public void update(String indexJson) throws IOException {
        MStdIndex mStdIndex = objectMapper.readValue(indexJson, MStdIndex.class);
        String version = mStdIndex.getVersion();
        JsonNode jsonNode = objectMapper.readTree(indexJson);
        SqlCreator sqlCreator = new SqlCreator(StdIndex.class);
        String sql = sqlCreator.updateDataByTableKey("std_index_"+version, jsonNode);
        Query query = getExeuteQuery(sqlCreator, sql);
        query.executeUpdate();
    }


    public boolean isUnique(String filters, String version) throws IOException {
        List<StdIndex> list = searchPage(StdIndex.class, StandardVersion.StdIndexTable,version, filters, null, null, null,true);
        if(CollectionUtils.isEmpty(list)){
            return false;
        }
        return true;
    }
}

