package com.yihu.hos.standard.service.standard;

import com.fasterxml.jackson.databind.JsonNode;
import com.yihu.hos.standard.model.standard.StdDatasetRelation;
import com.yihu.hos.web.framework.baseservice.BaseService;
import com.yihu.hos.web.framework.util.sql.SqlCreator;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import java.io.IOException;
import java.util.List;


@Transactional
@Service
public class StdRelationService extends BaseService<StdDatasetRelation> {

    @Transactional
    public boolean modifyRelation(String version,List<StdDatasetRelation>  stdDatasetRelations) {
        boolean b = false;
        String tableName = "std_dataset_relation_"+version;
        String deleteSql = "DELETE FROM "+tableName;
        try {
            //删除该表记录
            jdbcTemplate.execute(deleteSql);
            //重新保存
            if(!CollectionUtils.isEmpty(stdDatasetRelations)){
                for (StdDatasetRelation model : stdDatasetRelations) {
                    SqlCreator sqlCreator = new SqlCreator(StdDatasetRelation.class);
                    JsonNode jsonNode =objectMapper.readTree(objectMapper.writeValueAsString(model));
                    String sql = sqlCreator.insertDataToSQL(tableName, jsonNode);
                    jdbcTemplate.execute(sql);
                }
            }
            b=true;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return b;
    }

}

