package com.yihu.hos.system.model;

import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.sql.Timestamp;
import java.util.Date;
import java.util.List;

/**
 * SystemUser entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "system_user")
public class SystemUser implements java.io.Serializable {
	public static final String ACTIVATED_DELETE="delete";//删除
	public static final String ACTIVATED_FORBIDDEN="forbidden";//禁用
	public static final String ACTIVATED_USEABLE="useable";//禁用
	// Fields
	@Id
	@GenericGenerator(name="idGenerator", strategy="uuid") //这个是hibernate的注解/生成32位UUID
	@GeneratedValue(generator="idGenerator")
	private String id;

	@Column(name = "login_code", nullable = false)
	private String loginCode;

	@Column(name = "password", nullable = false)
	private String password;

	@Column(name = "salt_value", nullable = true)
	private String saltValue;

	@Column(name = "activated", nullable = true)
	private String activated;

	@Column(name = "org_id", nullable = true)
	private String orgId;

	@Column(name = "user_name", nullable = true)
	private String userName;

	@Column(name = "user_email", nullable = true)
	private String userEmail;

	@Column(name = "user_mobile", nullable = true)
	private String userMobile;

	@Column(name = "user_sex", nullable = true)
	private String userSex;

	@Column(name = "user_birthday", nullable = true)
	private String userBirthday;

	@Column(name = "user_qq", nullable = true)
	private String userQq;

	@Column(name = "user_wechat", nullable = true)
	private String userWechat;

	@Column(name = "last_login_time", nullable = true)
	private Date lastLoginTime;


	@Transient
	private List<String> roles;

	// Constructors

	/** default constructor */
	public SystemUser() {
	}

	/** minimal constructor */
	public SystemUser(String loginCode, String password, String saltValue, String activated, String userName) {
		this.loginCode = loginCode;
		this.password = password;
		this.saltValue = saltValue;
		this.activated = activated;
		this.userName = userName;
	}

	/** full constructor */
	public SystemUser(String loginCode, String password, String saltValue, String activated, String orgId, String userName, String userEmail, String userMobile, String userSex, String userBirthday, String userQq, String userWechat, Timestamp lastLoginTime) {
		this.loginCode = loginCode;
		this.password = password;
		this.saltValue = saltValue;
		this.activated = activated;
		this.orgId = orgId;
		this.userName = userName;
		this.userEmail = userEmail;
		this.userMobile = userMobile;
		this.userSex = userSex;
		this.userBirthday = userBirthday;
		this.userQq = userQq;
		this.userWechat = userWechat;
		this.lastLoginTime = lastLoginTime;
	}

	// Property accessors

	public String getId() {
		return this.id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getLoginCode() {
		return this.loginCode;
	}

	public void setLoginCode(String loginCode) {
		this.loginCode = loginCode;
	}

	public String getPassword() {
		return this.password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getSaltValue() {
		return this.saltValue;
	}

	public void setSaltValue(String saltValue) {
		this.saltValue = saltValue;
	}

	public String getActivated() {
		return this.activated;
	}

	public void setActivated(String activated) {
		this.activated = activated;
	}

	public String getOrgId() {
		return this.orgId;
	}

	public void setOrgId(String orgId) {
		this.orgId = orgId;
	}

	public String getUserName() {
		return this.userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public String getUserEmail() {
		return this.userEmail;
	}

	public void setUserEmail(String userEmail) {
		this.userEmail = userEmail;
	}

	public String getUserMobile() {
		return this.userMobile;
	}

	public void setUserMobile(String userMobile) {
		this.userMobile = userMobile;
	}

	public String getUserSex() {
		return this.userSex;
	}

	public void setUserSex(String userSex) {
		this.userSex = userSex;
	}

	public String getUserBirthday() {
		return this.userBirthday;
	}

	public void setUserBirthday(String userBirthday) {
		this.userBirthday = userBirthday;
	}

	public String getUserQq() {
		return this.userQq;
	}

	public void setUserQq(String userQq) {
		this.userQq = userQq;
	}

	public String getUserWechat() {
		return this.userWechat;
	}

	public void setUserWechat(String userWechat) {
		this.userWechat = userWechat;
	}

	public Date getLastLoginTime() {
		return this.lastLoginTime;
	}

	public void setLastLoginTime(Date lastLoginTime) {
		this.lastLoginTime = lastLoginTime;
	}

	public List<String> getRoles() {
		return roles;
	}

	public void setRoles(List<String> roles) {
		this.roles = roles;
	}
}