package com.yihu.hos;

import com.yihu.ehr.redis.client.RedisClient;
import com.yihu.hos.qc.service.RuleService;
import com.yihu.hos.redis.schema.std.StdQcMetaDataKeySchema;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.io.Serializable;
import java.util.List;

/**
 * Created by Administrator on 2018/5/28.
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class StdQcMetaDataKeySchemaTest {

    @Autowired
    private StdQcMetaDataKeySchema stdQcMetaDataKeySchema;

    @Resource(name = RuleService.BEAN_ID)
    private RuleService ruleService;

    @Autowired
    RedisClient redisClient;

    @Test
    public void getMetaDataByDataSet(){
        List<String> hdsa00_01 = stdQcMetaDataKeySchema.getMetaDataByDataSet("59083976eebd", "HDSA00_01");
        System.out.println(hdsa00_01);
    }

    @Test
    public void getQcMetaData(){
        String HDSA00_01_003 = stdQcMetaDataKeySchema.getQcMetaData("59083976eebd", "HDSA00_89","JDSA00_89_005");
        System.out.println(HDSA00_01_003);
    }

    @Test
    public void getValue(){
        Serializable HDSA00_01_003 = stdQcMetaDataKeySchema.getValue("qc_59083976eebd:HDSA00_89:JDSA00_89_005");
        System.out.println(HDSA00_01_003.toString());
    }


    @Test
    public void bindQcRuleByDataSet(){
        ruleService.bindQcRuleByDataSet("59083976eebd", 1l);

        Serializable HDSA00_01_003 = stdQcMetaDataKeySchema.getValue("qc_59083976eebd:HDSA00_01:HDSA00_01_003");
        System.out.println(HDSA00_01_003.toString());
    }


    @Test
    public void setValue2(){
        String key1="qc_test:test:value";
         redisClient.set(key1,"test111");
    }

    @Test
    public void getValue2(){
        String key1="qc_59083976eebd:HDSB02_04:HDSB02_04_129";
        redisClient.set(key1," emptyCheck");
        Object o = redisClient.get(key1);
        System.out.println(o.toString());
    }


}
